using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Movable_Crosshairs
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private TIS.Imaging.ICImagingControl icImagingControl1;
        private TIS.Imaging.OverlayBitmap _ob;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 7);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(376, 15);
            this.label1.TabIndex = 0;
            this.label1.Text = "Click to mark a position. Shift-click to mark multiple positions.";
            // 
            // icImagingControl1
            // 
            this.icImagingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.icImagingControl1.BackColor = System.Drawing.Color.White;
            this.icImagingControl1.DeviceListChangedExecutionMode = TIS.Imaging.EventExecutionMode.Invoke;
            this.icImagingControl1.DeviceLostExecutionMode = TIS.Imaging.EventExecutionMode.AsyncInvoke;
            this.icImagingControl1.ImageAvailableExecutionMode = TIS.Imaging.EventExecutionMode.MultiThreaded;
            this.icImagingControl1.LiveDisplayPosition = new System.Drawing.Point(0, 0);
            this.icImagingControl1.Location = new System.Drawing.Point(8, 22);
            this.icImagingControl1.Name = "icImagingControl1";
            this.icImagingControl1.Size = new System.Drawing.Size(320, 243);
            this.icImagingControl1.TabIndex = 1;
            this.icImagingControl1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.icImagingControl1_KeyDown);
            this.icImagingControl1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.icImagingControl1_KeyUp);
            this.icImagingControl1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseDown);
            this.icImagingControl1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseMove);
            this.icImagingControl1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseUp);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(336, 270);
            this.Controls.Add(this.icImagingControl1);
            this.Controls.Add(this.label1);
            this.MinimumSize = new System.Drawing.Size(344, 281);
            this.Name = "Form1";
            this.Text = "Movable Crosshairs";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		bool bDragging = false;
        bool ShiftPressed = false;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();

			if( !icImagingControl1.DeviceValid ) 
			{
				Close();
				return;
			}
            
            _ob = icImagingControl1.OverlayBitmapAtPath[TIS.Imaging.PathPositions.Device];
            _ob.Enable = true;
            _ob.ColorMode = TIS.Imaging.OverlayColorModes.Color;
			icImagingControl1.LiveStart();
		}
		
        private void icImagingControl1_MouseDown(object sender, MouseEventArgs e)
		{
            if (!ShiftPressed)
			{
                _ob.Fill(_ob.DropOutColor );
			}

			DrawCrosshairs( e.X, e.Y );

			bDragging = true;
		}
        private void icImagingControl1_MouseMove(object sender, MouseEventArgs e)
		{
			if( bDragging )
			{
                if (!ShiftPressed)
				{
                    _ob.Fill(_ob.DropOutColor );
				}

				DrawCrosshairs( e.X, e.Y );
			}
		}
        private void icImagingControl1_MouseUp(object sender, MouseEventArgs e)
		{
			bDragging = false;
		}
		
        private void DrawCrosshairs(int x, int y)
        {
            _ob.DrawLine(Color.Red, x, y - 10, x, y + 10);
            _ob.DrawLine(Color.Red, x - 10, y, x + 10, y);
            _ob.DrawText(Color.Blue, x + 3, y + 2, x.ToString() + "," + y.ToString());
        }

        private void icImagingControl1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Modifiers == Keys.Shift)
            {
                ShiftPressed = true;
            }
        }

        private void icImagingControl1_KeyUp(object sender, KeyEventArgs e)
        {
            ShiftPressed = false;
        }    
	}
}
